package cache

import (
	"os"

	"github.com/mjwhitta/errors"
	"github.com/mjwhitta/pathname"
)

// Cache related vars
var (
	cacheDir  string = pathname.ExpandPath("~/.cache/arTTY")
	cacheFile string = "art.json"
	jsonDir   string = "json"
)

// CustomJSONDir is the location where custom JSON files generated by
// the user are saved.
var CustomJSONDir string = pathname.ExpandPath(
	"~/.config/arTTY/" + jsonDir,
)

func init() {
	var sys string = "/usr/local/share/arTTY"

	if ok, e := pathname.DoesExist(CustomJSONDir); e != nil {
		panic(errors.Newf("failed to access cache directory: %w", e))
	} else if !ok {
		if e := os.MkdirAll(CustomJSONDir, os.ModePerm); e != nil {
			e = errors.Newf("failed to create cache directory: %w", e)
			panic(e)
		}
	}

	// Check if system cache exists
	if ok, _ := pathname.DoesExist(cacheDir); !ok {
		if ok, _ := pathname.DoesExist(sys); ok {
			cacheDir = sys
		}
	}
}
